/*
Feladat: Rendezzünk egy számokból álló N elemű sorozatot!
Közben számláljuk a hasonlítások és a mozgatások számát!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
int hDb, mDb; //hasonlítások, mozgatások száma

void beolvasas(int& n, int x[]) {
	cerr << "Elemek szama (0.." << MAXN << "):";
	cin >> n;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". egesz szam: "; 
		cin >> x[i];
	}
}

void rendezes(const int& n, int x[]) {
	for(int i = 1; i < n; i++) {
		int j = i - 1;
		int y = x[i];
		mDb++; //mozgatás
		hDb++; //az első hasonlítás a ciklusfeltételben
		while(j >= 0 && x[j] > y) {
			mDb++; //mozgatás
			x[j + 1] = x[j];
			j--;
			hDb++; //a következő hasonlítás a ciklusfeltételben
		}
		x[j + 1] = y;
		mDb++; //mozgatás
	}
}

void kiiras(const int& n, int x[]) {
	cerr << "Az elemek novekvoen rendezve:";
	for (int i = 0; i < n; i++) {
		cout << i + 1 << ".:" << x[i] << endl;
	}
	cout << "Hasonlitasok szama:" << hDb << endl; 
    cout << "Mozgatasok szama:" << mDb << endl; 
}

int main() {
	
	int n, x[MAXN];
	
	beolvasas(n, x);
	hDb = 0;
	mDb = 0;
	
	rendezes(n, x);
	kiiras(n, x);
	
	return 0;
}