/*
Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
Közben számláljuk a kulcsmező-indexelések és a mozgatások számát!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
int kDb, mDb; //kulcsmező-indexelések, mozgatások száma

struct Elem {
	int kulcs;
	string tart;
};

void beolvasas(int& n, Elem x[]) {
	cerr << "Elemek szama (0.." << MAXN << "):";
	cin >> n;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". kulcs (1.." << n << ") es a szoveg tartalom:"; 
		cin >> x[i].kulcs >> x[i].tart;
	}
}

void rendezes(int& n, Elem x[], Elem y[]) {
	for (int i = 0; i < n; i++) {
		y[x[i].kulcs - 1] = x[i];
		kDb++;
		mDb++;
	}
}

void kiiras(const int& n, Elem y[]) {
	cerr << "Az elemek novekvoen rendezve:";
	for (int i = 0; i < n; i++) {
		cout << i + 1 << ".:" << y[i].kulcs << " " << y[i].tart << endl;
	}
	cout << "Kulcsmezo-indexelesek szama:" << kDb << endl; 
    cout << "Mozgatasok szama:" << mDb << endl; 
}

int main() {
	
	int n, m;
	Elem x[MAXN], y[MAXN];
	
	beolvasas(n, x);
	kDb = 0;
	mDb = 0;
	
	rendezes(n, x, y);
	kiiras(n, y);
	
	return 0;
}