//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static long kDb=0;
	static long mDb=0;
	
	static class Item {
		int kulcs;
		String tart;
	}
	
    static class Input {
        int N;
        Item[] X;
        int M;
    }
	
	static class Output {
        Item[] Y;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.X=new Item[input.N];
		for (int i=0;i<input.N;i++) {
			input.X[i]=new Item();
			input.X[i].kulcs=io.nextInt();
			input.X[i].tart=io.next();
		}
		input.M=input.X[0].kulcs;
		for (int i=1;i<input.N;i++) {
			if (input.M<input.X[i].kulcs) {
				input.M=input.X[i].kulcs;
			}
		}
        return input;
    }
	
	static void kiir(IO io, Input input,Output output) throws IOException {
		for (int i=0;i<input.N;i++) {
			io.writeLn(""+(i+1)+".:"+output.Y[i].kulcs+" "+output.Y[i].tart);
		}
		io.writeLn("Kulcsmezo-indexelesek szama:"+kDb);
		io.writeLn("Mozgatasok szama:"+mDb);
    }
	
	static Output Rendezes(Input input){
		Output output=new Output();
		output.Y=new Item[input.N];
		int db[]=new int[input.M];
		for (int i=0;i<input.M;i++) {
			db[i]=0;
		}
		for (int i=0;i<input.N;i++) {
			db[input.X[i].kulcs-1]++;
			kDb++;
		}
		int elso[]=new int[input.M];
		elso[0]=1;
		for (int j=1;j<input.M;j++) {
			elso[j]=elso[j-1]+db[j-1];
		}
		for (int i=0;i<input.N;i++) {
			output.Y[elso[input.X[i].kulcs-1]-1]=new Item();
			output.Y[elso[input.X[i].kulcs-1]-1].kulcs=input.X[i].kulcs;
			output.Y[elso[input.X[i].kulcs-1]-1].tart=input.X[i].tart;
			elso[input.X[i].kulcs-1]++;
			kDb++;
			mDb++;
			kDb++;
		}
		return output;
	}
	   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);
		kDb=0;
		mDb=0;
        Output output=Rendezes(input);

        kiir(io, input, output);

        io.close();
    }

}