'''
Feladat: Rendezzünk egy számokból álló N elemű sorozatot!
Közben számláljuk a hasonlítások és a mozgatások számát!
'''
import sys

def Beolvasás():
    sys.stderr.write("Elemek száma:")
    N=int(input())
    X=[]
    for i in range(N):
        sys.stderr.write(str(i+1)+". egész szám: ")                     
        X.append(int(input())) 
    return X # N-re értékét a listából is kiolvashatjuk, a Pythonban nincs rá szükség
                 
def Rendezés(X): # Pythonban van beépített rendezés: sorted(X), sort(X)
    hDb=0 # hasonlítások száma
    mDb=0 # mozgatások száma
    for i in range(1,len(X)): #Az indexelés 0-tól kezdődik, így az algoritmushoz képest elcsúsztatjuk a hivatkozásokat
        j=i-1 
        y=X[i]
        mDb+=1 # mozgatás
        hDb+=1 #az első hasonlítás a ciklusfeltételben
        while (j>=0) and (X[j]>y):
            mDb+=1 # mozgatás
            X[j+1]=X[j]
            j-=1
            hDb+=1 #a következő hasonlítás a ciklusfeltételben	 
        X[j+1]=y
        mDb+=1 # mozgatás
    return hDb,mDb,X  

def Kiirás(hDb,mDb,X):
   
    sys.stderr.write("Az elemek novekvoen rendezve:")
    for i in range(len(X)):
        print(str(i+1)+".:"+str(X[i]))
    print("Hasonlitasok szama:"+str(hDb)) 
    print("Mozgatasok szama:"+str(mDb))
  
X=Beolvasás()
hDb,mDb,X =Rendezés(X)
Kiirás(hDb,mDb,X )

