/*
Feladat: Rendezzünk egy számokból álló N elemű sorozatot!
Közben számláljuk a hasonlítások és a mozgatások számát!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
int hDb, mDb; //hasonlítások, mozgatások száma

void beolvasas(int& n, int x[]) {
	cerr << "Elemek szama (0.." << MAXN << "):";
	cin >> n;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". egesz szam: "; 
		cin >> x[i];
	}
}

void csere(int& a, int& b) {
	int tmp = a;
	a = b;
	b = tmp;
	mDb += 3;
}

void rendezes(const int& n, int x[]) {
	int i = n - 1;
	while(i >= 1) {
		int cs = 0;
		for(int j = 0; j <=	i - 1; j++) {
			hDb++;
			if(x[j] > x[j + 1]) {
				csere(x[j], x[j + 1]);
				cs = j;
			}
		}
		i = cs;
	}
}

void kiiras(const int &n, const int x[]) {
	cerr << "Az elemek novekvoen rendezve:";
	for (int i = 0; i < n; i++) {
		cout << i + 1 << ".:" << x[i] << endl;
	}
	cout << "Hasonlitasok szama:" << hDb << endl; 
    cout << "Mozgatasok szama:" << mDb << endl; 
}

int main() {
	
	int n, x[MAXN];
	
	beolvasas(n, x);
	hDb = 0;
	mDb = 0;
	
	rendezes(n, x);
	kiiras(n, x);
	
	return 0;
}