﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Beillesztéses rendezés
*/
namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, int[] X)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány számot olvasunk be? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("A(z) " + (i + 1) + ". elem: ");
                X[i] = Convert.ToInt32(Console.ReadLine());
            }
        }
       
       static void Rendezés(int N, int[] X, ref int mDb, ref int hDb)
        {
            for (int i = 1; i < N; i++)
            {
                int j = i - 1;
                int y = X[i];
                mDb++; //mozgatás
                hDb++; //az első hasonlítás a ciklusfeltételben
                while (j >= 0 && X[j] > y)
                {
                    mDb++; //mozgatás
                    X[j + 1] = X[j];
                    j--;
                    hDb++; //a következő hasonlítás a ciklusfeltételben
                }
                X[j + 1] = y;
                mDb++; //mozgatás
            }
        }

        static void Kiírás(int N, int[] X, int mDb, int hDb)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            Console.Error.WriteLine("Rendezett sorozat: ");
            for (int i = 0; i < N; i++)
            {
                Console.WriteLine("{0}. elem: {1}",(i+1),X[i]);
            }
            Console.WriteLine("Hasonlítások száma: {0}",hDb);
            Console.WriteLine("Mozgatások száma: {0}", mDb);
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            //A tömb deklarálása
            int[] X = new int[MaxN];
            //Statisztikai adatok deklarálása
            int mDb = 0;//Mozgatások száma
            int hDb = 0;//Hasonlítások száma
            //Beolvasás
            Beolvasás(out N, X);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Rendezés
            Rendezés(N, X, ref mDb, ref hDb);
            //Kiírás
            Kiírás(N, X, mDb, hDb);
        }
    }
}
