//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static long mDb=0;
	static long hDb=0;
	
    static class Input {
        int N;
        int[] X;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.X=new int[input.N];
		for (int i=0;i<input.N;i++) {
			input.X[i]=io.nextInt();
		}
        return input;
    }
	
	static void kiir(IO io, Input input) throws IOException {
		for (int i=0;i<input.N;i++) {
			io.writeLn(""+(i+1)+".:"+input.X[i]);
		}
		io.writeLn("Hasonlitasok szama:"+hDb);
		io.writeLn("Mozgatasok szama:"+mDb);
    }
	
	static void Rendezes(Input in){
		for (int i=2;i<=in.N;i++) {
			int j=i-1;
			mDb++;
			int y=in.X[i-1];
			hDb++;
			while ((j>0) && (in.X[j-1]>y)) {
				mDb++;
				in.X[j]=in.X[j-1];
				j--;
				hDb++;
			}
			mDb++;
			in.X[j]=y;
		}
	}
	   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);
		hDb=0;
		mDb=0;
        Rendezes(input);

        kiir(io, input);

        io.close();
    }

}