//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static long mDb=0;
	static long hDb=0;
	
    static class Input {
        int N;
        int[] X;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.X=new int[input.N];
		for (int i=0;i<input.N;i++) {
			input.X[i]=io.nextInt();
		}
        return input;
    }
	
	static void kiir(IO io, Input input) throws IOException {
		for (int i=0;i<input.N;i++) {
			io.writeLn(""+(i+1)+".:"+input.X[i]);
		}
		io.writeLn("Hasonlitasok szama:"+hDb);
		io.writeLn("Mozgatasok szama:"+mDb);
    }

	static void Csere(Input in,int e, int f){
		mDb++;
		int s=in.X[e];
		mDb++;
		in.X[e]=in.X[f];
		mDb++;
		in.X[f]=s;
		
	}
	
	static void Rendezes(Input in){
		for (int i=0;i<in.N-1;i++) {
			int min=i;
			for (int j=i+1;j<in.N;j++) {
				hDb++;
				if (in.X[min]>in.X[j]) {
					min=j;
				}
			}
			Csere(in,i,min);
		}
	}
	   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);
		hDb=0;
		mDb=0;
        Rendezes(input);

        kiir(io, input);

        io.close();
    }

}