//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static long kDb=0;
	static long mDb=0;
	
	static class Item {
		int kulcs;
		String tart;
	}
	
    static class Input {
        int N;
        Item[] X;
    }
	
	static class Output {
        Item[] Y;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.X=new Item[input.N];
		for (int i=0;i<input.N;i++) {
			input.X[i]=new Item();
			input.X[i].kulcs=io.nextInt();
			input.X[i].tart=io.next();
		}
        return input;
    }
	
	static void kiir(IO io, Input input,Output output) throws IOException {
		for (int i=0;i<input.N;i++) {
			io.writeLn(""+(i+1)+".:"+output.Y[i].kulcs+" "+output.Y[i].tart);
		}
		io.writeLn("Kulcsmezo-indexelesek szama:"+kDb);
		io.writeLn("Mozgatasok szama:"+mDb);
    }
	
	static Output Rendezes(Input input){
		Output output=new Output();
		output.Y=new Item[input.N];
		for (int i=0;i<input.N;i++) {
			output.Y[input.X[i].kulcs-1]=new Item();
			output.Y[input.X[i].kulcs-1].kulcs=input.X[i].kulcs;
			output.Y[input.X[i].kulcs-1].tart=input.X[i].tart;
			mDb++;
			kDb++;
		}
		return output;
	}
	   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);
		kDb=0;
		mDb=0;
        Output output=Rendezes(input);

        kiir(io, input, output);

        io.close();
    }

}