Program Beilleszteses_rendezes;
(*
  Feladat: Rendezzünk egy számokból álló N elemű sorozatot!
  *        Közben számláljuk a hasonlítások és a mozgaástosk számát!
*)
  Const
    MaxN=100;
  Type
    TElem=Integer;
    TEgeszek=Array [1..MaxN] of TElem;
  Var
    N:Integer;
    X:TEgeszek;
    hDb,mDb:LongInt;//hasonlítások, mozgatások száma

  Procedure Beolvasas(Var N:Integer; Var X:TEgeszek);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatornára írandók!
    //Például a kérdések:
    Write(StdErr,'Elemek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. egesz szam:'); 
      Readln(X[i]);
    End;
  End;

  Procedure Rendezes(Const N:Integer; Var X:TEgeszek);
    Var
      i,j,y:Integer;
  Begin
    For i:=2 to N do
    Begin
      j:=i-1; 
      y:=X[i];
      Inc(mDb);//mozgatás
	  Inc(hDb);//az első hasonlítás a ciklusfeltételben
	  While (j>0) and (X[j]>y) do
	  Begin
	    Inc(mDb);//mozgatás
	    X[j+1]:=X[j]; Dec(j);
	    Inc(hDb);//a következő hasonlítás a ciklusfeltételben
	  End;
	  X[j+1]:=y;
      Inc(mDb);//mozgatás
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const X:TEgeszek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Writeln(StdErr,'Az elemek novekvoen rendezve:'); 
    For i:=1 to N do
    Begin
	  Writeln(i,'.:',X[i]);
    End;
    Writeln('Hasonlitasok szama:',hDb); 
    Writeln('Mozgatasok szama:',mDb); 
  End;
  
Begin
  Beolvasas(N,X);
  hDb:=0; mDb:=0;
  Rendezes(N,X);
  Kiiras(N,X);
End.
