Program Minimum_kivalasztasos_rendezes;
(*
  Feladat: Rendezzünk egy számokból álló N elemű sorozatot!
  *        Közben számláljuk a hasonlítások és a mozgaástosk számát!
*)
  Const
    MaxN=100;
  Type
    TElem=Integer;
    TEgeszek=Array [1..MaxN] of TElem;
  Var
    N:Integer;
    X:TEgeszek;
    hDb,mDb:LongInt;//hasonlítások, mozgatások száma

  Procedure Beolvasas(Var N:Integer; Var X:TEgeszek);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatornára írandók!
    //Például a kérdések:
    Write(StdErr,'Elemek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. egesz szam:'); 
      Readln(X[i]);
    End;
  End;

  Procedure Rendezes(Const N:Integer; Var X:TEgeszek);
    Var
      i,j,min:Integer;

    Procedure Csere(Var e,f:TElem);
      Var
        s:TElem;
    Begin
      s:=e; e:=f; f:=s;
	  Inc(mDb,3);
    End;
    
  Begin
    For i:=1 to N-1 do
    Begin
      min:=i;
	  For j:=i+1 to N do
	  Begin
	    Inc(hDb);
        If X[min]>X[j] then min:=j;
	  End;
	  Csere(X[i],X[min]);
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const X:TEgeszek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Writeln(StdErr,'Az elemek novekvoen rendezve:'); 
    For i:=1 to N do
    Begin
	  Writeln(i,'.:',X[i]);
    End;
    Writeln('Hasonlitasok szama:',hDb); 
    Writeln('Mozgatasok szama:',mDb); 
  End;
  
Begin
  Beolvasas(N,X);
  hDb:=0; mDb:=0;
  Rendezes(N,X);
  Kiiras(N,X);
End.
