Program Szetoszto_rendezes;
(*
  Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
  *        Közben számláljuk a kulcsmező-indexelések és a mozgaástosk számát!
*)
  Const
    MaxN=100;
  Type
    TElem=Record kulcs:Integer; tart:String End;
    TKulcsosSzovegek=Array [1..MaxN] of TElem;
  Var
    N:Integer;
    X,Y:TKulcsosSzovegek;
    kDb,mDb:LongInt;//kulcsmező-indexelések, mozgatások száma

  Procedure Beolvasas(Var N:Integer; Var X:TKulcsosSzovegek);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatornára írandók!
    //Például a kérdések:
    Write(StdErr,'Elemek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. kulcs (1..',N,') es a szoveg tartalom:'); 
      Readln(X[i].kulcs,X[i].tart);
    End;
  End;

  Procedure Rendezes(Const N:Integer; Const X:TKulcsosSzovegek; Var Y:TKulcsosSzovegek);
    Var
      i:Integer;
  Begin
    For i:=1 to N do
    Begin
      Y[X[i].kulcs]:=X[i];
      Inc(kDb); Inc(mDb);
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const Y:TKulcsosSzovegek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Writeln(StdErr,'Az elemek novekvoen rendezve:'); 
    For i:=1 to N do
    Begin
	  Writeln(i,'.:',Y[i].kulcs,Y[i].tart);
    End;
    Writeln('Kulcsmezo-indexelesek szama:',kDb); 
    Writeln('Mozgatasok szama:',mDb); 
  End;
  
Begin
  Beolvasas(N,X);
  kDb:=0; mDb:=0;
  Rendezes(N,X,Y);
  Kiiras(N,Y);
End.
