'''
Szétosztó rendezés

  Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
           Közben számláljuk a kulcsmező-indexelések és a mozgatások számát!
'''
  
import sys
def Beolvasás():
    sys.stderr.write("Elemek száma:")
    N=int(input())
    X=[]
    for i in range(N):
        sys.stderr.write(str(i+1)+". kulcs (1.."+str(N)+") és szöveg: ")
        sor=input().split()
        X.append((int(sor[0]),sor[1])) # most tuple listában tároljuk,
                                       # a Pythonban van más lehetőség is: szótárban tárolhatjuk, beépített rendezést hasznűlhatnánk   
    return N,X

def Rendezés(N,X):  
    kDb=0
    mDb=0
    Y=[0]*(N+1) #plusz egy elem, hiszen 0-tóé kezdődik az indexelés
    for i in range( N):   
      Y[X[i][0]]=X[i]
      kDb+=1
      mDb+=1
    return Y,kDb,mDb

def Kiirás(N,Y,mDb,kDb):  
    sys.stderr.write("Az elemek növekvően rendezve:\n")
    print(Y)
    for i in range(1,N+1):
            print(str(i)+".:"+str(Y[i][0])+" "+Y[i][1])
    print("Kulcsmező-indexelések száma:"+str(kDb)) 
    print("Mozgatások száma:"+str(mDb))
   
N,X=Beolvasás()
Y,mDb,kDb=Rendezés(N,X)
Kiirás( N,Y,mDb,kDb)

'''
#Megoldás a nyelv beépített lehetőségével.

szótár={}
N=int(input())
for i in range(N):
    sys.stderr.write(str(i+1)+". kulcs (1.."+str(N)+") és szöveg: ")
    sor=input().split()
    szótár[int(sor[0])]=sor[1]
for kulcs in szótár.keys():
    print(str(kulcs)+" "+szótár[kulcs])
'''            
